/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the InboxSettingsWebPush type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InboxSettingsWebPush{}

// InboxSettingsWebPush struct for InboxSettingsWebPush
type InboxSettingsWebPush struct {
	PublicKey string `json:"public_key"`
}

// NewInboxSettingsWebPush instantiates a new InboxSettingsWebPush object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInboxSettingsWebPush(publicKey string) *InboxSettingsWebPush {
	this := InboxSettingsWebPush{}
	this.PublicKey = publicKey
	return &this
}

// NewInboxSettingsWebPushWithDefaults instantiates a new InboxSettingsWebPush object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInboxSettingsWebPushWithDefaults() *InboxSettingsWebPush {
	this := InboxSettingsWebPush{}
	return &this
}

// GetPublicKey returns the PublicKey field value
func (o *InboxSettingsWebPush) GetPublicKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value
// and a boolean to check if the value has been set.
func (o *InboxSettingsWebPush) GetPublicKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.PublicKey, true
}

// SetPublicKey sets field value
func (o *InboxSettingsWebPush) SetPublicKey(v string) {
	o.PublicKey = v
}

func (o InboxSettingsWebPush) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InboxSettingsWebPush) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["public_key"] = o.PublicKey
	return toSerialize, nil
}

type NullableInboxSettingsWebPush struct {
	value *InboxSettingsWebPush
	isSet bool
}

func (v NullableInboxSettingsWebPush) Get() *InboxSettingsWebPush {
	return v.value
}

func (v *NullableInboxSettingsWebPush) Set(val *InboxSettingsWebPush) {
	v.value = val
	v.isSet = true
}

func (v NullableInboxSettingsWebPush) IsSet() bool {
	return v.isSet
}

func (v *NullableInboxSettingsWebPush) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInboxSettingsWebPush(val *InboxSettingsWebPush) *NullableInboxSettingsWebPush {
	return &NullableInboxSettingsWebPush{value: val, isSet: true}
}

func (v NullableInboxSettingsWebPush) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInboxSettingsWebPush) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


